var isPromise = require('is-promise')

exports.init = function(db, key, adapter) {
  db.read = function() {
    var r = adapter.read();
    return isPromise(r) ? r.then(db.plant) : db.plant(r);
  };
  db.write = function(value) {
    value = value || db.getState();
    var w = adapter.write(db.getState());
    function next() {
      return value;
    }
    return isPromise(w) ? w.then(next) : value;
  };
  db.plant = function(state) {
    db[key] = state;
    return db;
  };
  db.getState = function() {
    return db[key];
  };
  db.setState = function(state) {
    db.plant(state);
    return db;
  };
  return db.read();
};
